import random

def merge(left, right):
    """assume left and right are already sorted"""
    left_finger = 0
    right_finger = 0
    merged = []

    while left_finger < len(left) and \
        right_finger < len(right):
        if left[left_finger] <= right[right_finger]:
            merged.append(left[left_finger])
            left_finger += 1
        else:
            merged.append(right[right_finger])
            right_finger += 1

    # we've gone through all the items from one list
    # just append everything from the remaining list
    if left_finger == len(left):
        # append the right
        # for i in range(right_finger, len(right)):
        #     merged.append(right[right_finger])
        # merged.extend(right[right_finger:])
        merged += right[right_finger:]
    else:
        # append the left
        merged += left[left_finger:]

    return merged

def merge_sort(arr):
    if len(arr) <= 1:
        return arr
    # split arr in half
    mid = int(len(arr) / 2)
    # mid = len(arr) // 2

    left = merge_sort(arr[:mid])
    right = merge_sort(arr[mid:])
    return merge(left, right)


arr = [random.random() for _ in range(100000)]
arr2 = merge_sort(arr)
assert all(arr2[i] >= arr2[i - 1] for i in range(1, len(arr2)))





